###############################################################################
# AdminSubList.pm                                                             #
# $Date: 06.01.17 $                                                           #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Packaged:       June 1, 2017                                                #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2017 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use strict;
use warnings;
no warnings qw(once);
our $VERSION            = '2.7.00';
our $adminsublistpmver  = 'YaBB 2.7.00 $Revision: 1848 $';
our @adminsublistpmmods = ();
our $adminsublistpmmods = 0;
if (@adminsublistpmmods) {
    $adminsublistpmmods = 1;
}

our %director = (
    'addboard'             => 'ManageBoards.pm&add_boards',
    'addboard2'            => 'ManageBoards.pm&add_boards2',
    'addcat'               => 'ManageCats.pm&add_cats',
    'addcat2'              => 'ManageCats.pm&add_cats2',
    'addmember'            => 'Admin.pm&addmember',
    'addmember2'           => 'Admin.pm&addmember2',
    'addsmilies'           => 'Smilies.pm&add_smilies',
    'admincheck'           => 'Admin.pm&admincheck',
    'admincheck2'          => 'Admin.pm&admincheck2',
    'admin_descision'      => 'RegistrationLog.pm&process_registration_review',
    'apr_regentry'         => 'RegistrationLog.pm&approve_registration',
    'assigned'             => 'MemberGroups.pm&Assigned_Members',
    'assigned2'            => 'MemberGroups.pm&Assigned_Members2',
    'ban_clean'            => 'Ban.pm&ban_clean',
    'banlog'               => 'Ban.pm&banlog',
    'backup'               => 'Backup.pm&backupsettings',
    'backupsettings2'      => 'Backup.pm&backupsettings2',
    'boardrecount'         => 'Maintenance.pm&admin_board_recount',
    'boardscreen'          => 'ManageBoards.pm&board_screen',
    'bookmarks'            => 'Settings_Bookmarks.pm&book_marks',
    'bookmarks2'           => 'Settings_Bookmarks.pm&book_marks2',
    'bookmarks_add'        => 'Settings_Bookmarks.pm&add_bookmark',
    'bookmarks_delete'     => 'Settings_Bookmarks.pm&delete_bookmark',
    'bookmarks_edit'       => 'Settings_Bookmarks.pm&edit_bookmark',
    'bookmarks_edit2'      => 'Settings_Bookmarks.pm&edit_bookmark2',
    'catscreen'            => 'ManageCats.pm&do_cats',
    'checkspace'           => 'Checkspace.pm&checkspace',
    'checkspace_save'      => 'Checkspace.pm&checkspace_save',
    'clean_log'            => 'Maintenance.pm&clean_log',
    'clean_reglog'         => 'RegistrationLog.pm&clean_reglog',
    'cleanerrorlog'        => 'ErrorLog.pm&clean_error_log',
    'del_regentry'         => 'RegistrationLog.pm&kill_registration',
    'deleteattachment'     => 'Attachments.pm&delete_attachments',
    'deletepmattachment'   => 'Attachments.pm&delete_pmattachments',
    'deletebackup'         => 'Backup.pm&deletebackup',
    'deletebackup2'        => 'Backup.pm&deletebackup2',
    'deleteerror'          => 'ErrorLog.pm&delete_error',
    'deletemail'           => 'AdminSubs.pm&mail_list',
    'deletemultimembers'   => 'Admin.pm&deletemultimembers',
    'deleteoldthreads'     => 'Admin.pm&deleteoldmessages',
    'delgroup'             => 'MemberGroups.pm&delete_group',
    'detailedversion'      => 'DetailedVersion.pm&ver_detail',
    'downloadbackup'       => 'Backup.pm&downloadbackup',
    'editAddGroup2'        => 'MemberGroups.pm&edit_add_group2',
    'editbots'             => 'AdminEdit.pm&editbots',
    'editbots2'            => 'AdminEdit.pm&editbots2',
    'editemailtemplates'   => 'EditEmailTemplates.pm&editemailtemplates',
    'editemailtemplates2'  => 'EditEmailTemplates.pm&editemailtemplates2',
    'editgroup'            => 'MemberGroups.pm&edit_add_group',
    'editgroup1'           => 'MemberGroups.pm&edit_add_group',
    'editpaths'            => 'AdminEdit.pm&edit_paths',
    'editpaths2'           => 'AdminEdit.pm&edit_paths2',
    'eventcal_set'         => 'EventCalSet.pm&event_calset',
    'eventcal_set2'        => 'EventCalSet.pm&event_calset2',
    'eventcal_set3'        => 'EventCalSet.pm&event_calset3',
    'emailbackup'          => 'Backup.pm&emailbackup',
    'errorlog'             => 'ErrorLog.pm&error_log',
    'ext_admin'            => 'Settings_ExtendedProfiles.pm&ext_admin',
    'ext_convert'          => 'Settings_ExtendedProfiles.pm&ext_admin_convert',
    'ext_create'           => 'Settings_ExtendedProfiles.pm&ext_admin_create',
    'ext_edit'             => 'Settings_ExtendedProfiles.pm&ext_admin_edit',
    'ext_edit2'            => 'Settings_ExtendedProfiles.pm&ext_admin_edit2',
    'ext_reorder'          => 'Settings_ExtendedProfiles.pm&ext_admin_reorder',
    'gmodaccess'           => 'AdminEdit.pm&gmod_settings',
    'gmodsettings2'        => 'AdminEdit.pm&gmod_settings2',
    'guardian_block'       => 'GuardianAdmin.pm&guardian_block',
    'helpadmin'            => 'EditHelpCentre.pm&main_admin',
    'edithelp'             => 'EditHelpCentre.pm&edithelp',
    'helpediting'          => 'EditHelpCentre.pm&help_edit',
    'helpediting2'         => 'EditHelpCentre.pm&help_edit2',
    'helporder'            => 'EditHelpCentre.pm&set_orderfile',
    'helpsettings2'        => 'EditHelpCentre.pm&helpset2',
    'honeypot'             => 'HoneyPot.pm&honeypot',
    'honeypot_add'         => 'HoneyPot.pm&honeypot_add',
    'honeypot_edit'        => 'HoneyPot.pm&honeypot_edit',
    'honeypot_edit2'       => 'HoneyPot.pm&honeypot_edit2',
    'honeypot_delete'      => 'HoneyPot.pm&honeypot_delete',
    'ipban'                => 'Ban.pm&ipban',
    'ipban_add'            => 'Ban.pm&ipban_add',
    'ipban_err'            => 'Ban.pm&ipban_err',
    'ipban2'               => 'Ban.pm&ipban2',
    'mailing'              => 'MailMembers.pm&mailing_members',
    'mailing2'             => 'MailMembers.pm&mailing2',
    'mailing3'             => 'MailMembers.pm&mailing3',
    'mailinggrps'          => 'MailMembers.pm&mailing',
    'mailmultimembers'     => 'Admin.pm&deletemultimembers',
    'manageattachments'    => 'Attachments.pm&attachments',
    'manageattachments2'   => 'Attachments.pm&attachments2',
    'manageboards'         => 'ManageBoards.pm&manage_boards',
    'managecats'           => 'ManageBoards.pm&manage_boards',
    'managepmattachments2' => 'Attachments.pm&pm_attachments2',
    'membershiprecount'    => 'Maintenance.pm&admin_membership_recount',
    'ml'                   => 'ViewMembers.pm&admin_ml',
    'modagreement'         => 'AdminEdit.pm&modifyagreement',
    'modagreement2'        => 'AdminEdit.pm&modifyagreement2',
    'modcss'               => 'ManageStyles.pm&modify_css',
    'modcss2'              => 'ManageStyles.pm&modify_css2',
    'modifycatorder'       => 'ManageCats.pm&reorder_cats',
    'modlist'              => 'ModList.pm&list_mods',
    'modmemgr'             => 'MemberGroups.pm&edit_member_groups',
    'modskin'              => 'ManageTemplates.pm&modify_skin',
    'modskin2'             => 'ManageTemplates.pm&modify_skin2',
    'modstyle'             => 'ManageStyles.pm&modify_style',
    'modstyle2'            => 'ManageStyles.pm&modify_style2',
    'modtemp'              => 'ManageTemplates.pm&modify_template',
    'modtemp2'             => 'ManageTemplates.pm&modify_template2',
    'newsettings'          => 'NewSettings.pm&settings',
    'newsettings2'         => 'NewSettings.pm&settings2',
    'rebuildattach'        => 'Attachments.pm&fullrebuild_attachents',
    'rebuildmemhist'       => 'Maintenance.pm&rebuild_memhistory',
    'rebuildmemlist'       => 'Maintenance.pm&rebuild_memlist',
    'rebuildmesindex'      => 'Maintenance.pm&rebuild_messageindex',
    'rebuildnotifications' => 'Maintenance.pm&rebuild_notifications',
    'rebuildpmattach'      => 'Attachments.pm&fullrebuild_pmattachments',
    'recoverbackup1'       => 'Backup.pm&recoverbackup1',
    'recoverbackup2'       => 'Backup.pm&recoverbackup2',
    'referer_control'      => 'Admin.pm&refcontrol',
    'referer_control2'     => 'Admin.pm&refcontrol2',
    'rej_regentry'         => 'RegistrationLog.pm&reject_registration',
    'remghostattach'       => 'Attachments.pm&remove_ghostattach',
    'remghostpmattach'     => 'Attachments.pm&remove_ghostpmattach',
    'removebigattachments' => 'Attachments.pm&removebigattachments',
    'removebigpmattachments' => 'Attachments.pm&removebig_pmattachments',
    'removeoldattachments'   => 'Attachments.pm&removeoldattachments',
    'removeoldpmattachments' => 'Attachments.pm&removeold_pmattachments',
    'removeoldthreads'       => 'RemoveOldTopics.pm&remove_old_threads',
    'reorderboards'          => 'ManageBoards.pm&reorder_boards',
    'reorderboards2'         => 'ManageBoards.pm&reorder_boards2',
    'reordercats'            => 'ManageCats.pm&reorder_cats',
    'reordercats2'           => 'ManageCats.pm&reorder_cats2',
    'reordergroup'           => 'MemberGroups.pm&reorder_groups',
    'reordergroup2'          => 'MemberGroups.pm&reorder_groups2',
    'runbackup'              => 'Backup.pm&runbackup',
    'setcensor'              => 'AdminEdit.pm&set_censor',
    'setcensor2'             => 'AdminEdit.pm&set_censor2',
    'setreserve'             => 'AdminEdit.pm&setreserve',
    'setreserve2'            => 'AdminEdit.pm&setreserve2',
    'setup_guardian'         => 'GuardianAdmin.pm&setup_guardian',
    'setup_guardian2'        => 'GuardianAdmin.pm&setup_guardian2',
    'showclicks'             => 'Admin.pm&showclicklog',
    'smiliemove'             => 'Smilies.pm&smilie_move',
    'smilies'                => 'Smilies.pm&smilie_panel',
    'spam_questions'         => 'AntispamQuestions.pm&spam_questions',
    'spam_questions2'        => 'AntispamQuestions.pm&spam_questions2',
    'spam_questions_add'     => 'AntispamQuestions.pm&spam_questionsadd',
    'spam_questions_delete'  => 'AntispamQuestions.pm&spam_questionsdelete',
    'spam_questions_edit'    => 'AntispamQuestions.pm&spam_questionsedit',
    'spam_questions_edit2'   => 'AntispamQuestions.pm&spam_questionsedit2',
    'stats'                  => 'Admin.pm&fullstats',
    'view_regentry'          => 'RegistrationLog.pm&view_registration',
    'view_reglog'            => 'RegistrationLog.pm&view_reglog',
    'viewmembers'            => 'ViewMembers.pm&admin_ml',
    'blockip'                => 'ErrorLog.pm&blockip',
    'modfolder'              => 'ManageTemplates.pm&new_template_folder',
    'modgfolder'             => 'ManageTemplates.pm&new_graphics_folder',
    'modfolder2'             => 'ManageTemplates.pm&new_template_folder2',
    'modfolderup'            => 'ManageTemplates.pm&new_template_upload',
    'fixboarddupes'          => 'ManageBoards.pm&fix_board_dupes',
    'fixdupes'               => 'ManageBoards.pm&fix_dupes',
    'yabmmodlist'            => 'YaBMod.pm&yabm_modlist',
    'yabmmodinfo'            => 'YaBMod.pm&yabm_modinfo',
    'yabmapplymod'           => 'YaBMod.pm&yabm_applymod',
    'yabmuninstallmod'       => 'YaBMod.pm&yabm_uninstallmod',
    'yabmuploadmod'          => 'YaBMod.pm&yabm_uploadmod',
    'yabmmodifymod'          => 'YaBMod.pm&yabm_modifymod',
    'yabmmodifymod2'         => 'YaBMod.pm&yabm_modifymod2',
    'yabmdeletemod'          => 'YaBMod.pm&yabm_deletemod',
    'clean_bak'              => 'YaBMod.pm&clean_bak',     ## Clean up .bak files ##
    'remsetup'               => 'Admin.pm&remsetup',
);

1;
