###############################################################################
# SubList.pm                                                                  #
# $Date: 06.01.17 $                                                           #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Packaged:       June 1, 2017                                                #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2017 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use strict;
use warnings;
no warnings qw(once);
our $VERSION = '2.7.00';

our $sublistpmver  = 'YaBB 2.7.00 $Revision: 1848 $';
our @sublistpmmods = ();
our $sublistpmmods = 0;
if (@sublistpmmods) {
    $sublistpmmods = 1;
}
our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

our %director = (
    'activate'            => 'Register.pm&user_activation',
    'addbuddy'            => 'Subs.pm&add_buddy',
    'addfav'              => 'Favorites.pm&add_fav',
    'addtab2'             => 'AdvancedTabs.pm&add_new_tab2',
    'ajxmessage'          => 'LivePreview.pm&dolive_message',
    'ajximmessage'        => 'LivePreview.pm&dolive_pm',
    'ajxcal'              => 'LivePreview.pm&dolive_cal',
    'bdrulecoll'          => 'MessageIndex.pm&collapse_bdrule',
    'boardnotify'         => 'Notify.pm&boardnotify',
    'boardnotify2'        => 'MyCenter.pm&mycenter',
    'boardnotify3'        => 'Notify.pm&boardnotify2',
    'checkboardpw'        => 'Subs.pm&boardpassw_check',
    'checkavail'          => 'UserSelect.pm&checkuser_avail',
    'collapse_all'        => 'BoardIndex.pm&collapse_all',
    'collapse_cat'        => 'BoardIndex.pm&collapse_cat',
    'deletemultimessages' => 'MyCenter.pm&del_some_im',
    'deletetab'           => 'AdvancedTabs.pm&delete_tab',
    'delpmfolder'         => 'MyCenter.pm&add_folder',
    'dereferer'           => 'Subs.pm&dereferer',
    'display'             => 'Display.pm&display_thread',
    'downloadfile'        => 'Downloads.pm&download_filecounter',
    'edittab2'            => 'AdvancedTabs.pm&edit_tab2',
    'eventcal'            => 'EventCal.pm&eventcal',
    'add_cal'             => 'EventCal.pm&add_cal',
    'del_cal'             => 'EventCal.pm&del_cal',
    'get_cal_ssi'         => 'EventCalSSI.pm&get_cal_ssi',
    'birthdaylist'        => 'EventCalBirthdays.pm&birthdaylist',
    'favorites'           => 'MyCenter.pm&mycenter',
    'findmember'          => 'UserSelect.pm&find_mem',
    'guestlang'           => 'Subs.pm&guestlang_set',
    'guestpm'             => 'Post.pm&send_guest_pm',
    'guestpm2'            => 'Post.pm&send_guest_pm2',
    'help'                => 'HelpCentre.pm&get_helpfiles',
    'hide'                => 'SetStatus.pm&set_status',
    'im'                  => 'MyCenter.pm&mycenter',
    'imcb'                => 'MyCenter.pm&call_back',
    'imdraft'             => 'MyCenter.pm&mycenter',
    'imlist'              => 'UserSelect.pm&member_list',
    'imoutbox'            => 'MyCenter.pm&mycenter',
    'imprint'             => 'Printpage.pm&print_im',
    'imsend'              => 'MyCenter.pm&mycenter',
    'imsend2'             => 'MyCenter.pm&mycenter',
    'imshow'              => 'MyCenter.pm&mycenter',
    'imstorage'           => 'MyCenter.pm&mycenter',
    'ipban_update'        => 'Security.pm&ipban_update',
    'iplookup'            => 'IPLookup.pm&ip_lookup',
    'jump'                => 'Subs.pm&dojump',
    'link_profileview'    => 'Subs.pm&link_profileview',
    'lock'                => 'SetStatus.pm&set_status',
    'lockpoll'            => 'Poll.pm&lock_poll',
    'login'               => 'LogInOut.pm&login',
    'login2'              => 'LogInOut.pm&login2',
    'logout'              => 'LogInOut.pm&logout',
    'markallasread'       => 'BoardIndex.pm&markallread',
    'markasread'          => 'MessageIndex.pm&mark_read',
    'markims'             => 'MyCenter.pm&mark_all',
    'markunread'          => 'Display.pm&undumplog',
    'memberpagedrop'      => 'Subs.pm&memberpage_index',
    'memberpagetext'      => 'Subs.pm&memberpage_index',
    'messageindex'        => 'MessageIndex.pm&message_index',
    'messagepagedrop'     => 'MessageIndex.pm&message_pageindex',
    'messagepagetext'     => 'MessageIndex.pm&message_pageindex',
    'ml'                  => 'Memberlist.pm&ml',
    'modalert'            => 'Post.pm&mod_alert',
    'modalert2'           => 'Post.pm&mod_alert2',
    'modify'              => 'ModifyMessage.pm&modify_message',
    'modify2'             => 'ModifyMessage.pm&modify_message2',
    'modsearch'           => 'AddModerators.pm&mod_search',
    'modsearch2'          => 'AddModerators.pm&mod_search2',
    'multiadmin'          => 'RemoveTopic.pm&multi',
    'multidel'            => 'ModifyMessage.pm&multi_del',
    'multiremfav'         => 'Favorites.pm&multi_rem_fav',
    'mycenter'            => 'MyCenter.pm&mycenter',
    'myprofile'           => 'MyCenter.pm&mycenter',
    'myprofile2'          => 'MyCenter.pm&mycenter',
    'myprofileAdmin'      => 'MyCenter.pm&mycenter',
    'myprofileAdmin2'     => 'MyCenter.pm&mycenter',
    'myprofileBuddy'      => 'MyCenter.pm&mycenter',
    'myprofileBuddy2'     => 'MyCenter.pm&mycenter',
    'myprofileContacts'   => 'MyCenter.pm&mycenter',
    'myprofileContacts2'  => 'MyCenter.pm&mycenter',
    'myprofileIM'         => 'MyCenter.pm&mycenter',
    'myprofileIM2'        => 'MyCenter.pm&mycenter',
    'myprofileOptions'    => 'MyCenter.pm&mycenter',
    'myprofileOptions2'   => 'MyCenter.pm&mycenter',
    'myusersrecentposts'  => 'MyCenter.pm&mycenter',
    'myviewprofile'       => 'MyCenter.pm&mycenter',
    'newpmfolder'         => 'MyCenter.pm&add_folder',
    'next'                => 'Display.pm&next_prev',
    'notify2'             => 'Notify.pm&notify2',
    'notify3'             => 'Notify.pm&notify3',
    'notify4'             => 'MyCenter.pm&mycenter',
    'pages'               => 'MessageIndex.pm&list_pages',
    'palette'             => 'Palette.pm&color_picker',
    'pmpagedrop'          => 'MyCenter.pm&pm_pageindex',
    'pmpagetext'          => 'MyCenter.pm&pm_pageindex',
    'pmsearch'            => 'MyCenter.pm&mycenter',
    'post'                => 'Post.pm&post',
    'post2'               => 'Post.pm&post2',
    'prev'                => 'Display.pm&next_prev',
    'print'               => 'Printpage.pm&print_post',
    'printthread'         => 'Printpage.pm&print_post',
    'profile'             => 'Profile.pm&modify_profile',
    'profile2'            => 'Profile.pm&modify_profile2',
    'profileAdmin'        => 'Profile.pm&modify_profile_admin',
    'profileAdmin2'       => 'Profile.pm&modify_profile_admin2',
    'profileBuddy'        => 'Profile.pm&modify_profile_buddy',
    'profileBuddy2'       => 'Profile.pm&modify_profile_buddy2',
    'profileCheck'        => 'Profile.pm&profile_check',
    'profileCheck2'       => 'Profile.pm&profile_check2',
    'profileContacts'     => 'Profile.pm&modify_profile_contacts',
    'profileContacts2'    => 'Profile.pm&modify_profile_contacts2',
    'profileIM'           => 'Profile.pm&modify_profile_pm',
    'profileIM2'          => 'Profile.pm&modify_profile_pm2',
    'profileOptions'      => 'Profile.pm&modify_profile_options',
    'profileOptions2'     => 'Profile.pm&modify_profile_options2',
    'qsearch'             => 'UserSelect.pm&quick_search',
    'qsearch2'            => 'UserSelect.pm&doquicksearch',
    'rearrsticky'         => 'System.pm&rearrange_sticky',
    'recent'              => 'Recent.pm&recent_posts',
    'recenttopics'        => 'Recent.pm&recent_topics',
    'register'            => 'Register.pm&register',
    'register2'           => 'Register.pm&register2',
    'remfav'              => 'Favorites.pm&rem_fav',
    'reminder'            => 'LogInOut.pm&reminder',
    'reminder2'           => 'LogInOut.pm&reminder2',
    'removethread'        => 'RemoveTopic.pm&delete_thread',
    'reordertab'          => 'AdvancedTabs.pm&reorder_tab',
    'resetpass'           => 'LogInOut.pm&reminder3',
    'revalidatesession'   => 'Sessions.pm&session_reval',
    'revalidatesession2'  => 'Sessions.pm&session_reval2',
    'RSSboard'            => 'RSS.pm&rss_board',
    'RSSrecent'           => 'RSS.pm&rss_recent',
    'scpoll'              => 'Poll.pm&showcase_poll',
    'scpolldel'           => 'Poll.pm&del_showcase_poll',
    'scpollcoll'          => 'Poll.pm&collapse_poll',
    'search'              => 'Search.pm&plush_search1',
    'search2'             => 'Search.pm&plush_search2',
    'sendtopic'           => 'SendTopic.pm&send_topic',
    'sendtopic2'          => 'SendTopic.pm&send_topic2',
    'setgtalk'            => 'Display.pm&set_gtalk',
    'showexternal'        => 'BoardIndex.pm&redirect_externalshow',
    'shownotify'          => 'MyCenter.pm&mycenter',
    'showvoters'          => 'Poll.pm&votedetails',
    'smilieindex'         => 'DoSmilies.pm&smilie_index',
    'smilieput'           => 'DoSmilies.pm&smilie_put',
    'split_splice'        => 'MoveSplitSplice.pm&split_splice',
    'sticky'              => 'SetStatus.pm&set_status',
    'threadpagedrop'      => 'Display.pm&threadpage_index',
    'threadpagetext'      => 'Display.pm&threadpage_index',
    'topicpreview'        => 'MessageIndex.pm&set_topicpreview',
    'undovote'            => 'Poll.pm&undo_vote',
    'usersrecentposts'    => 'Profile.pm&usersrecentposts',
    'viewdownloads'       => 'Downloads.pm&downloadview',
    'viewprofile'         => 'Profile.pm&view_profile',
    'vote'                => 'Poll.pm&do_vote',
    'ban_page_a'          => 'Security.pm&ban_page_a',
    'ban_page_b'          => 'Security.pm&ban_page_b',
    'yabmodsource'        => 'YaBModSource.pm&yabmodsource',          # YaBMod
    'guardian_blck'       => 'Guardian.pm&guardian_blck',
    'ipban_gip'           => 'Security.pm&ipban_gip',
);

1;
